GeographicLib 2.3

Static Public Member Functions | List of all members
GeographicLib::OSGB Class Reference

Ordnance Survey grid system for Great Britain. More...

`#include <GeographicLib/OSGB.hpp>`

## Static Public Member Functions
static void | Forward (real lat, real lon, real &x, real &y, real &gamma, real &k)
static void | Reverse (real x, real y, real &lat, real &lon, real &gamma, real &k)
static void | Forward (real lat, real lon, real &x, real &y)
static void | Reverse (real x, real y, real &lat, real &lon)
static void | GridReference (real x, real y, int prec, std::string &gridref)
static void | GridReference (const std::string &gridref, real &x, real &y, int &prec, bool centerp=true)
Inspector functions
static Math::real | EquatorialRadius ()
static Math::real | Flattening ()
static Math::real | CentralScale ()
static Math::real | OriginLatitude ()
static Math::real | OriginLongitude ()
static Math::real | FalseNorthing ()
static Math::real | FalseEasting ()

## Detailed Description

Ordnance Survey grid system for Great Britain.

The class implements the coordinate system used by the Ordnance Survey for maps of Great Britain and conversions to the grid reference system.

See

- A guide to coordinate systems in Great Britain
- Using the National Grid

Warning
  the latitudes and longitudes for the Ordnance Survey grid system do not use the WGS84 datum. Do not use the values returned by this class in the UTMUPS, MGRS, or Geoid classes without first converting the datum (and vice versa).

Example of use:

// Example of using the GeographicLib::OSGB class
#include <iostream>
#include <iomanip>
#include <exception>
#include <string>
#include <GeographicLib/OSGB.hpp>
#include <GeographicLib/DMS.hpp>
using namespace std;
using namespace GeographicLib;
int main() {
try {
{
// Sample forward calculation from
// A guide to coordinate systems in Great Britain
double
lat = DMS::Decode(52,39,27.2531),
lon = DMS::Decode( 1,43, 4.5177);
double x, y;
OSGB::Forward(lat, lon, x, y);
string gridref;
OSGB::GridReference(x, y, 2, gridref);
cout << fixed << setprecision(3)
<< x << " " << y << " " << gridref << "\n";
}
{
// Sample reverse calculation
string gridref = "TG5113";
double x, y;
int prec;
OSGB::GridReference(gridref, x, y, prec);
double lat, lon;
OSGB::Reverse(x, y, lat, lon);
cout << fixed << setprecision(8)
<< prec << " " << lat << " " << lon << "\n";
}
}
catch (const exception& e) {
cerr << "Caught exception: " << e.what() << "\n";
return 1;
}
}
main
int main(int argc, const char *const argv[])
Definition: CartConvert.cpp:29
DMS.hpp
Header for GeographicLib::DMS class.
OSGB.hpp
Header for GeographicLib::OSGB class.
GeographicLib::DMS::Decode
static Math::real Decode(const std::string &dms, flag &ind)
Definition: DMS.cpp:40
GeographicLib::OSGB::GridReference
static void GridReference(real x, real y, int prec, std::string &gridref)
Definition: OSGB.cpp:39
GeographicLib::OSGB::Forward
static void Forward(real lat, real lon, real &x, real &y, real &gamma, real &k)
Definition: OSGB.hpp:81
GeographicLib::OSGB::Reverse
static void Reverse(real x, real y, real &lat, real &lon, real &gamma, real &k)
Definition: OSGB.hpp:102
GeographicLib
Namespace for GeographicLib.
Definition: Accumulator.cpp:12
std
Definition: NearestNeighbor.hpp:812

Definition at line 44 of file OSGB.hpp.

## Member Function Documentation

## ◆ Forward() [1/2]

static void GeographicLib::OSGB::Forward | ( | real | lat,
|  | real | lon,
|  | real & | x,
|  | real & | y,
|  | real & | gamma,
|  | real & | k
| ) |  |
| inline static

Forward projection, from geographic to OSGB coordinates.

Parameters

  [in] | lat | latitude of point (degrees).
  [in] | lon | longitude of point (degrees).
  [out] | x | easting of point (meters).
  [out] | y | northing of point (meters).
  [out] | gamma | meridian convergence at point (degrees).
  [out] | k | scale of projection at point.

lat should be in the range [−90°, 90°].

Definition at line 81 of file OSGB.hpp.

References GeographicLib::TransverseMercator::Forward().

## ◆ Reverse() [1/2]

static void GeographicLib::OSGB::Reverse | ( | real | x,
|  | real | y,
|  | real & | lat,
|  | real & | lon,
|  | real & | gamma,
|  | real & | k
| ) |  |
| inline static

Reverse projection, from OSGB coordinates to geographic.

Parameters

  [in] | x | easting of point (meters).
  [in] | y | northing of point (meters).
  [out] | lat | latitude of point (degrees).
  [out] | lon | longitude of point (degrees).
  [out] | gamma | meridian convergence at point (degrees).
  [out] | k | scale of projection at point.

The value of lon returned is in the range [−180°, 180°].

Definition at line 102 of file OSGB.hpp.

References GeographicLib::TransverseMercator::Reverse().

## ◆ Forward() [2/2]

static void GeographicLib::OSGB::Forward | ( | real | lat,
|  | real | lon,
|  | real & | x,
|  | real & | y
| ) |  |
| inline static

OSGB::Forward without returning the convergence and scale.

Definition at line 112 of file OSGB.hpp.

## ◆ Reverse() [2/2]

static void GeographicLib::OSGB::Reverse | ( | real | x,
|  | real | y,
|  | real & | lat,
|  | real & | lon
| ) |  |
| inline static

OSGB::Reverse without returning the convergence and scale.

Definition at line 120 of file OSGB.hpp.

## ◆ GridReference() [1/2]

void GeographicLib::OSGB::GridReference | ( | real | x,
|  | real | y,
|  | int | prec,
|  | std::string & | gridref
| ) |  |
| static

Convert OSGB coordinates to a grid reference.

Parameters

  [in] | x | easting of point (meters).
  [in] | y | northing of point (meters).
  [in] | prec | precision relative to 100 km.
  [out] | gridref | National Grid reference.

Exceptions

  GeographicErr | if prec, x, or y is outside its allowed range.
  std::bad_alloc | if the memory for gridref can't be allocatied.

prec specifies the precision of the grid reference string as follows:

- prec = 0 (min), 100km
- prec = 1, 10km
- prec = 2, 1km
- prec = 3, 100m
- prec = 4, 10m
- prec = 5, 1m
- prec = 6, 0.1m
- prec = 11 (max), 1μm

The easting must be in the range [−1000 km, 1500 km) and the northing must be in the range [−500 km, 2000 km). These bounds are consistent with rules for the letter designations for the grid system.

If x or y is NaN, the returned grid reference is "INVALID".

Definition at line 39 of file OSGB.cpp.

References GeographicLib::Utility::str().

## ◆ GridReference() [2/2]

void GeographicLib::OSGB::GridReference | ( | const std::string & | gridref,
|  | real & | x,
|  | real & | y,
|  | int & | prec,
|  | bool | centerp = `true`
| ) |  |
| static

Convert OSGB grid reference to coordinates.

Parameters

  [in] | gridref | National Grid reference.
  [out] | x | easting of point (meters).
  [out] | y | northing of point (meters).
  [out] | prec | precision relative to 100 km.
  [in] | centerp | if true (default), return center of the grid square, else return SW (lower left) corner.

Exceptions

  GeographicErr | if gridref is illegal.

The grid reference must be of the form: two letters (not including I) followed by an even number of digits (up to 22).

If the first 2 characters of gridref are "IN", then x and y are set to NaN and prec is set to −2.

Definition at line 93 of file OSGB.cpp.

References GeographicLib::Utility::lookup(), and GeographicLib::Math::NaN().

## ◆ EquatorialRadius()

static Math::real GeographicLib::OSGB::EquatorialRadius | ( |  | ) |
| inline static

Returns
  a the equatorial radius of the Airy 1830 ellipsoid (meters).

This is 20923713 ft converted to meters using the rule 1 ft = 109.48401603−10 m. The Airy 1830 value is returned because the OSGB projection is based on this ellipsoid. The conversion factor from feet to meters is the one used for the 1936 retriangulation of Britain; see Section A.1 (footnote 10 on p. 44) of A guide to coordinate systems in Great Britain, v3.6 (2020).

Definition at line 190 of file OSGB.hpp.

## ◆ Flattening()

static Math::real GeographicLib::OSGB::Flattening | ( |  | ) |
| inline static

Returns
  f the inverse flattening of the Airy 1830 ellipsoid.

For the Airy 1830 ellipsoid, a = 20923713 ft and b = 20853810 ft; thus the flattening = (20923713 − 20853810)/20923713 = 7767/2324857 = 1/299.32496459... (The Airy 1830 value is returned because the OSGB projection is based on this ellipsoid.)

Definition at line 205 of file OSGB.hpp.

## ◆ CentralScale()

static Math::real GeographicLib::OSGB::CentralScale | ( |  | ) |
| inline static

Returns
  k0 central scale for the OSGB projection (0.9996012717...).

C. J. Mugnier, Grids & Datums, PE&RS, Oct. 2003, states that this is defined as 109.9998268−10.

Definition at line 214 of file OSGB.hpp.

## ◆ OriginLatitude()

static Math::real GeographicLib::OSGB::OriginLatitude | ( |  | ) |
| inline static

Returns
  latitude of the origin for the OSGB projection (49 degrees).

Definition at line 222 of file OSGB.hpp.

## ◆ OriginLongitude()

static Math::real GeographicLib::OSGB::OriginLongitude | ( |  | ) |
| inline static

Returns
  longitude of the origin for the OSGB projection (−2 degrees).

Definition at line 228 of file OSGB.hpp.

## ◆ FalseNorthing()

static Math::real GeographicLib::OSGB::FalseNorthing | ( |  | ) |
| inline static

Returns
  false northing the OSGB projection (−100000 meters).

Definition at line 233 of file OSGB.hpp.

## ◆ FalseEasting()

static Math::real GeographicLib::OSGB::FalseEasting | ( |  | ) |
| inline static

Returns
  false easting the OSGB projection (400000 meters).

Definition at line 238 of file OSGB.hpp.

The documentation for this class was generated from the following files:

- OSGB.hpp
- OSGB.cpp